From 156d5e9b132dc39c42ebf6d883822be8048152f6 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jun 21 2017 13:41:17 +0000
Subject: [PATCH 874/1001] Be more resilient with incoming messages


---

diff --git a/hubs/widgets/bugzilla/__init__.py b/hubs/widgets/bugzilla/__init__.py
index a9e0c4f..8939130 100644
--- a/hubs/widgets/bugzilla/__init__.py
+++ b/hubs/widgets/bugzilla/__init__.py
@@ -90,6 +90,12 @@ class GetIssues(CachedFunction):
         return issues
 
     def should_invalidate(self, message):
+        if "bug" not in message["msg"]:
+            return False
+        try:
+            component = message['msg']['bug']['component']
+        except KeyError:
+            return False
         username = self.instance.config["username"]
         url = "/".join([PKGDB_URL, username])
         response = requests.get(url)
@@ -97,7 +103,4 @@ class GetIssues(CachedFunction):
 
         owned = data['point of contact'] + data['co-maintained']
         owned = [p['name'] for p in owned]
-        if message['msg']['bug']['component'] in owned:
-            return True
-
-        return False
+        return (component in owned)
diff --git a/hubs/widgets/fedmsgstats/__init__.py b/hubs/widgets/fedmsgstats/__init__.py
index afcdf2e..70f545e 100644
--- a/hubs/widgets/fedmsgstats/__init__.py
+++ b/hubs/widgets/fedmsgstats/__init__.py
@@ -1,5 +1,7 @@
 from __future__ import unicode_literals
 
+import json
+
 import flask
 import fedmsg.config
 import fedmsg.meta
@@ -56,7 +58,10 @@ class GetStats(CachedFunction):
         url = "https://apps.fedoraproject.org/datagrepper/raw?user={username}"
         url = url.format(username=username)
         response = requests.get(url)
-        fedmsgs = response.json()['total']
+        try:
+            fedmsgs = response.json()['total']
+        except json.decoder.JSONDecodeError:
+            fedmsgs = 0
         sub_list = []
         for assoc in self.instance.hub.associations:
             if assoc.user:
diff --git a/hubs/widgets/pagure_pr/__init__.py b/hubs/widgets/pagure_pr/__init__.py
index cce7322..0eec25a 100644
--- a/hubs/widgets/pagure_pr/__init__.py
+++ b/hubs/widgets/pagure_pr/__init__.py
@@ -77,5 +77,8 @@ class GetPRs(CachedFunction):
         if category != "pagure":
             # TODO -- this could be honed in more to just PRs
             return False
-        return (message['msg']['project']['name'] ==
-                self.instance.config['repo'])
+        try:
+            project = message['msg']['project']['name']
+        except KeyError:
+            return False
+        return (project == self.instance.config['repo'])
diff --git a/hubs/widgets/workflow/pendingacls.py b/hubs/widgets/workflow/pendingacls.py
index b30a208..9ceb94b 100644
--- a/hubs/widgets/workflow/pendingacls.py
+++ b/hubs/widgets/workflow/pendingacls.py
@@ -63,7 +63,7 @@ class GetPending(CachedFunction):
             return False
         # Search the message to see if I am in the ACLs list of the request.
         username = self.instance.config["username"]
-        for acl in message['msg']['package_listing']['acls']:
+        for acl in message['msg']['package_listing'].get('acls', []):
             if acl['fas_name'] == username and acl['status'] == 'Approved':
                 return True
         return False

